<template>
  <v-select
    v-model="selectedValue"
    :label="label"
    :items="data"
    :item-value="itemValue"
    :item-text="itemText"
    :readonly="readonly"
    @change="getExchangeRate($event)"
    return-object
    :rules="rules"
    required
  />
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator'
import api from '../../plugins/api'

@Component({})
export default class CurrencySelect extends Vue {
  @Prop({ required: true }) value!: string
  @Prop({ default: 'Monedha*' }) label!: string
  @Prop({ default: false }) readonly!: boolean
  @Prop({ default: 'id' }) itemValue!: string
  @Prop({ default: 'currency' }) itemText!: string

  data: any[] = []
  rules = [value => !!value || 'Fusha nuk mund të lihet bosh']
  public get selectedValue() {
    return this.value
  }

  public set selectedValue(newValue: string) {
    this.$emit('input', newValue)
  }

  fetchData() {
    api()
      .get('/api/sales-management/checkout-info')
      .then(response => {
        this.data = response.data.data.currencies
      })
  }

  getExchangeRate(event) {
    const officialSellRate = event.official_sell_rate
    this.$emit('exchange-rate', officialSellRate)
    this.$emit('currency', event.currency)
    this.$emit('currency_id', event.id)
  }
  getRule() {
    this.$emit('rule', this.rules)
  }

  mounted() {
    this.fetchData()
  }
}
</script>
